Merge branch 'so/glossary-ancestor'
[git/git.git] / t / test-lib.sh
1 # Test framework for git. See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 ################################################################
53 # It appears that people try to run tests without building...
54 "$GIT_BUILD_DIR/git" >/dev/null
55 if test $? != 1
56 then
57 echo >&2 'error: you do not seem to have built git yet.'
58 exit 1
59 fi
60
61 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62 export PERL_PATH SHELL_PATH
63
64 # if --tee was passed, write the output not only to the terminal, but
65 # additionally to the file test-results/$BASENAME.out, too.
66 case "$GIT_TEST_TEE_STARTED, $* " in
67 done,*)
68 # do not redirect again
69 ;;
70 *' --tee '*|*' --va'*|*' --verbose-log '*)
71 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
73
74 # Make this filename available to the sub-process in case it is using
75 # --verbose-log.
76 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77 export GIT_TEST_TEE_OUTPUT_FILE
78
79 # Truncate before calling "tee -a" to get rid of the results
80 # from any previous runs.
81 >"$GIT_TEST_TEE_OUTPUT_FILE"
82
83 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
84 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
85 test "$(cat "$BASE.exit")" = 0
86 exit
87 ;;
88 esac
89
90 # For repeatability, reset the environment to known value.
91 # TERM is sanitized below, after saving color control sequences.
92 LANG=C
93 LC_ALL=C
94 PAGER=cat
95 TZ=UTC
96 export LANG LC_ALL PAGER TZ
97 EDITOR=:
98 # A call to "unset" with no arguments causes at least Solaris 10
99 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
100 # deriving from the command substitution clustered with the other
101 # ones.
102 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
103 my @env = keys %ENV;
104 my $ok = join("|", qw(
105 TRACE
106 DEBUG
107 TEST
108 .*_TEST
109 PROVE
110 VALGRIND
111 UNZIP
112 PERF_
113 CURL_VERBOSE
114 TRACE_CURL
115 ));
116 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
117 print join("\n", @vars);
118 ')
119 unset XDG_CACHE_HOME
120 unset XDG_CONFIG_HOME
121 unset GITPERLLIB
122 GIT_AUTHOR_EMAIL=author@example.com
123 GIT_AUTHOR_NAME='A U Thor'
124 GIT_COMMITTER_EMAIL=committer@example.com
125 GIT_COMMITTER_NAME='C O Mitter'
126 GIT_MERGE_VERBOSITY=5
127 GIT_MERGE_AUTOEDIT=no
128 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
129 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
130 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
131 export EDITOR
132
133 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
134 GIT_TRACE_BARE=1
135 export GIT_TRACE_BARE
136
137 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
138 then
139 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
140 export GIT_INDEX_VERSION
141 fi
142
143 # Add libc MALLOC and MALLOC_PERTURB test
144 # only if we are not executing the test with valgrind
145 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
146 test -n "$TEST_NO_MALLOC_CHECK"
147 then
148 setup_malloc_check () {
149 : nothing
150 }
151 teardown_malloc_check () {
152 : nothing
153 }
154 else
155 setup_malloc_check () {
156 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
157 export MALLOC_CHECK_ MALLOC_PERTURB_
158 }
159 teardown_malloc_check () {
160 unset MALLOC_CHECK_ MALLOC_PERTURB_
161 }
162 fi
163
164 # Protect ourselves from common misconfiguration to export
165 # CDPATH into the environment
166 unset CDPATH
167
168 unset GREP_OPTIONS
169 unset UNZIP
170
171 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
172 1|2|true)
173 GIT_TRACE=4
174 ;;
175 esac
176
177 # Convenience
178 #
179 # A regexp to match 5, 35 and 40 hexdigits
180 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
181 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
182 _x40="$_x35$_x05"
183
184 # Zero SHA-1
185 _z40=0000000000000000000000000000000000000000
186
187 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
188 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
189
190 # Line feed
191 LF='
192 '
193
194 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
195 # when case-folding filenames
196 u200c=$(printf '\342\200\214')
197
198 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
199
200 # Each test should start with something like this, after copyright notices:
201 #
202 # test_description='Description of this test...
203 # This test checks if command xyzzy does the right thing...
204 # '
205 # . ./test-lib.sh
206 test "x$TERM" != "xdumb" && (
207 test -t 1 &&
208 tput bold >/dev/null 2>&1 &&
209 tput setaf 1 >/dev/null 2>&1 &&
210 tput sgr0 >/dev/null 2>&1
211 ) &&
212 color=t
213
214 while test "$#" -ne 0
215 do
216 case "$1" in
217 -d|--d|--de|--deb|--debu|--debug)
218 debug=t; shift ;;
219 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
220 immediate=t; shift ;;
221 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
222 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
223 -r)
224 shift; test "$#" -ne 0 || {
225 echo 'error: -r requires an argument' >&2;
226 exit 1;
227 }
228 run_list=$1; shift ;;
229 --run=*)
230 run_list=${1#--*=}; shift ;;
231 -h|--h|--he|--hel|--help)
232 help=t; shift ;;
233 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
234 verbose=t; shift ;;
235 --verbose-only=*)
236 verbose_only=${1#--*=}
237 shift ;;
238 -q|--q|--qu|--qui|--quie|--quiet)
239 # Ignore --quiet under a TAP::Harness. Saying how many tests
240 # passed without the ok/not ok details is always an error.
241 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
242 --with-dashes)
243 with_dashes=t; shift ;;
244 --no-color)
245 color=; shift ;;
246 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
247 valgrind=memcheck
248 shift ;;
249 --valgrind=*)
250 valgrind=${1#--*=}
251 shift ;;
252 --valgrind-only=*)
253 valgrind_only=${1#--*=}
254 shift ;;
255 --tee)
256 shift ;; # was handled already
257 --root=*)
258 root=${1#--*=}
259 shift ;;
260 --chain-lint)
261 GIT_TEST_CHAIN_LINT=1
262 shift ;;
263 --no-chain-lint)
264 GIT_TEST_CHAIN_LINT=0
265 shift ;;
266 -x)
267 # Some test scripts can't be reliably traced with '-x',
268 # unless the test is run with a Bash version supporting
269 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
270 # this test is marked as such, and ignore '-x' if it
271 # isn't executed with a suitable Bash version.
272 if test -z "$test_untraceable" || {
273 test -n "$BASH_VERSION" && {
274 test ${BASH_VERSINFO[0]} -gt 4 || {
275 test ${BASH_VERSINFO[0]} -eq 4 &&
276 test ${BASH_VERSINFO[1]} -ge 1
277 }
278 }
279 }
280 then
281 trace=t
282 else
283 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
284 fi
285 shift ;;
286 --verbose-log)
287 verbose_log=t
288 shift ;;
289 *)
290 echo "error: unknown test option '$1'" >&2; exit 1 ;;
291 esac
292 done
293
294 if test -n "$valgrind_only"
295 then
296 test -z "$valgrind" && valgrind=memcheck
297 test -z "$verbose" && verbose_only="$valgrind_only"
298 elif test -n "$valgrind"
299 then
300 test -z "$verbose_log" && verbose=t
301 fi
302
303 if test -n "$trace" && test -z "$verbose_log"
304 then
305 verbose=t
306 fi
307
308 if test -n "$color"
309 then
310 # Save the color control sequences now rather than run tput
311 # each time say_color() is called. This is done for two
312 # reasons:
313 # * TERM will be changed to dumb
314 # * HOME will be changed to a temporary directory and tput
315 # might need to read ~/.terminfo from the original HOME
316 # directory to get the control sequences
317 # Note: This approach assumes the control sequences don't end
318 # in a newline for any terminal of interest (command
319 # substitutions strip trailing newlines). Given that most
320 # (all?) terminals in common use are related to ECMA-48, this
321 # shouldn't be a problem.
322 say_color_error=$(tput bold; tput setaf 1) # bold red
323 say_color_skip=$(tput setaf 4) # blue
324 say_color_warn=$(tput setaf 3) # brown/yellow
325 say_color_pass=$(tput setaf 2) # green
326 say_color_info=$(tput setaf 6) # cyan
327 say_color_reset=$(tput sgr0)
328 say_color_="" # no formatting for normal text
329 say_color () {
330 test -z "$1" && test -n "$quiet" && return
331 eval "say_color_color=\$say_color_$1"
332 shift
333 printf "%s\\n" "$say_color_color$*$say_color_reset"
334 }
335 else
336 say_color() {
337 test -z "$1" && test -n "$quiet" && return
338 shift
339 printf "%s\n" "$*"
340 }
341 fi
342
343 TERM=dumb
344 export TERM
345
346 error () {
347 say_color error "error: $*"
348 GIT_EXIT_OK=t
349 exit 1
350 }
351
352 say () {
353 say_color info "$*"
354 }
355
356 if test -n "$HARNESS_ACTIVE"
357 then
358 if test "$verbose" = t || test -n "$verbose_only"
359 then
360 printf 'Bail out! %s\n' \
361 'verbose mode forbidden under TAP harness; try --verbose-log'
362 exit 1
363 fi
364 fi
365
366 test "${test_description}" != "" ||
367 error "Test script did not set test_description."
368
369 if test "$help" = "t"
370 then
371 printf '%s\n' "$test_description"
372 exit 0
373 fi
374
375 exec 5>&1
376 exec 6<&0
377 exec 7>&2
378 if test "$verbose_log" = "t"
379 then
380 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
381 elif test "$verbose" = "t"
382 then
383 exec 4>&2 3>&1
384 else
385 exec 4>/dev/null 3>/dev/null
386 fi
387
388 # Send any "-x" output directly to stderr to avoid polluting tests
389 # which capture stderr. We can do this unconditionally since it
390 # has no effect if tracing isn't turned on.
391 #
392 # Note that this sets up the trace fd as soon as we assign the variable, so it
393 # must come after the creation of descriptor 4 above. Likewise, we must never
394 # unset this, as it has the side effect of closing descriptor 4, which we
395 # use to show verbose tests to the user.
396 #
397 # Note also that we don't need or want to export it. The tracing is local to
398 # this shell, and we would not want to influence any shells we exec.
399 BASH_XTRACEFD=4
400
401 test_failure=0
402 test_count=0
403 test_fixed=0
404 test_broken=0
405 test_success=0
406
407 test_external_has_tap=0
408
409 die () {
410 code=$?
411 if test -n "$GIT_EXIT_OK"
412 then
413 exit $code
414 else
415 echo >&5 "FATAL: Unexpected exit with code $code"
416 exit 1
417 fi
418 }
419
420 GIT_EXIT_OK=
421 trap 'die' EXIT
422 trap 'exit $?' INT
423
424 # The user-facing functions are loaded from a separate file so that
425 # test_perf subshells can have them too
426 . "$TEST_DIRECTORY/test-lib-functions.sh"
427
428 # You are not expected to call test_ok_ and test_failure_ directly, use
429 # the test_expect_* functions instead.
430
431 test_ok_ () {
432 test_success=$(($test_success + 1))
433 say_color "" "ok $test_count - $@"
434 }
435
436 test_failure_ () {
437 test_failure=$(($test_failure + 1))
438 say_color error "not ok $test_count - $1"
439 shift
440 printf '%s\n' "$*" | sed -e 's/^/# /'
441 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
442 }
443
444 test_known_broken_ok_ () {
445 test_fixed=$(($test_fixed+1))
446 say_color error "ok $test_count - $@ # TODO known breakage vanished"
447 }
448
449 test_known_broken_failure_ () {
450 test_broken=$(($test_broken+1))
451 say_color warn "not ok $test_count - $@ # TODO known breakage"
452 }
453
454 test_debug () {
455 test "$debug" = "" || eval "$1"
456 }
457
458 match_pattern_list () {
459 arg="$1"
460 shift
461 test -z "$*" && return 1
462 for pattern_
463 do
464 case "$arg" in
465 $pattern_)
466 return 0
467 esac
468 done
469 return 1
470 }
471
472 match_test_selector_list () {
473 title="$1"
474 shift
475 arg="$1"
476 shift
477 test -z "$1" && return 0
478
479 # Both commas and whitespace are accepted as separators.
480 OLDIFS=$IFS
481 IFS=' ,'
482 set -- $1
483 IFS=$OLDIFS
484
485 # If the first selector is negative we include by default.
486 include=
487 case "$1" in
488 !*) include=t ;;
489 esac
490
491 for selector
492 do
493 orig_selector=$selector
494
495 positive=t
496 case "$selector" in
497 !*)
498 positive=
499 selector=${selector##?}
500 ;;
501 esac
502
503 test -z "$selector" && continue
504
505 case "$selector" in
506 *-*)
507 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
508 then
509 echo "error: $title: invalid non-numeric in range" \
510 "start: '$orig_selector'" >&2
511 exit 1
512 fi
513 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
514 then
515 echo "error: $title: invalid non-numeric in range" \
516 "end: '$orig_selector'" >&2
517 exit 1
518 fi
519 ;;
520 *)
521 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
522 then
523 echo "error: $title: invalid non-numeric in test" \
524 "selector: '$orig_selector'" >&2
525 exit 1
526 fi
527 esac
528
529 # Short cut for "obvious" cases
530 test -z "$include" && test -z "$positive" && continue
531 test -n "$include" && test -n "$positive" && continue
532
533 case "$selector" in
534 -*)
535 if test $arg -le ${selector#-}
536 then
537 include=$positive
538 fi
539 ;;
540 *-)
541 if test $arg -ge ${selector%-}
542 then
543 include=$positive
544 fi
545 ;;
546 *-*)
547 if test ${selector%%-*} -le $arg \
548 && test $arg -le ${selector#*-}
549 then
550 include=$positive
551 fi
552 ;;
553 *)
554 if test $arg -eq $selector
555 then
556 include=$positive
557 fi
558 ;;
559 esac
560 done
561
562 test -n "$include"
563 }
564
565 maybe_teardown_verbose () {
566 test -z "$verbose_only" && return
567 exec 4>/dev/null 3>/dev/null
568 verbose=
569 }
570
571 last_verbose=t
572 maybe_setup_verbose () {
573 test -z "$verbose_only" && return
574 if match_pattern_list $test_count $verbose_only
575 then
576 exec 4>&2 3>&1
577 # Emit a delimiting blank line when going from
578 # non-verbose to verbose. Within verbose mode the
579 # delimiter is printed by test_expect_*. The choice
580 # of the initial $last_verbose is such that before
581 # test 1, we do not print it.
582 test -z "$last_verbose" && echo >&3 ""
583 verbose=t
584 else
585 exec 4>/dev/null 3>/dev/null
586 verbose=
587 fi
588 last_verbose=$verbose
589 }
590
591 maybe_teardown_valgrind () {
592 test -z "$GIT_VALGRIND" && return
593 GIT_VALGRIND_ENABLED=
594 }
595
596 maybe_setup_valgrind () {
597 test -z "$GIT_VALGRIND" && return
598 if test -z "$valgrind_only"
599 then
600 GIT_VALGRIND_ENABLED=t
601 return
602 fi
603 GIT_VALGRIND_ENABLED=
604 if match_pattern_list $test_count $valgrind_only
605 then
606 GIT_VALGRIND_ENABLED=t
607 fi
608 }
609
610 want_trace () {
611 test "$trace" = t && {
612 test "$verbose" = t || test "$verbose_log" = t
613 }
614 }
615
616 # This is a separate function because some tests use
617 # "return" to end a test_expect_success block early
618 # (and we want to make sure we run any cleanup like
619 # "set +x").
620 test_eval_inner_ () {
621 # Do not add anything extra (including LF) after '$*'
622 eval "
623 want_trace && set -x
624 $*"
625 }
626
627 test_eval_ () {
628 # If "-x" tracing is in effect, then we want to avoid polluting stderr
629 # with non-test commands. But once in "set -x" mode, we cannot prevent
630 # the shell from printing the "set +x" to turn it off (nor the saving
631 # of $? before that). But we can make sure that the output goes to
632 # /dev/null.
633 #
634 # There are a few subtleties here:
635 #
636 # - we have to redirect descriptor 4 in addition to 2, to cover
637 # BASH_XTRACEFD
638 #
639 # - the actual eval has to come before the redirection block (since
640 # it needs to see descriptor 4 to set up its stderr)
641 #
642 # - likewise, any error message we print must be outside the block to
643 # access descriptor 4
644 #
645 # - checking $? has to come immediately after the eval, but it must
646 # be _inside_ the block to avoid polluting the "set -x" output
647 #
648
649 test_eval_inner_ "$@" </dev/null >&3 2>&4
650 {
651 test_eval_ret_=$?
652 if want_trace
653 then
654 set +x
655 fi
656 } 2>/dev/null 4>&2
657
658 if test "$test_eval_ret_" != 0 && want_trace
659 then
660 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
661 fi
662 return $test_eval_ret_
663 }
664
665 test_run_ () {
666 test_cleanup=:
667 expecting_failure=$2
668
669 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
670 # turn off tracing for this test-eval, as it simply creates
671 # confusing noise in the "-x" output
672 trace_tmp=$trace
673 trace=
674 # 117 is magic because it is unlikely to match the exit
675 # code of other programs
676 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
677 then
678 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
679 fi
680 trace=$trace_tmp
681 fi
682
683 setup_malloc_check
684 test_eval_ "$1"
685 eval_ret=$?
686 teardown_malloc_check
687
688 if test -z "$immediate" || test $eval_ret = 0 ||
689 test -n "$expecting_failure" && test "$test_cleanup" != ":"
690 then
691 setup_malloc_check
692 test_eval_ "$test_cleanup"
693 teardown_malloc_check
694 fi
695 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
696 then
697 echo ""
698 fi
699 return "$eval_ret"
700 }
701
702 test_start_ () {
703 test_count=$(($test_count+1))
704 maybe_setup_verbose
705 maybe_setup_valgrind
706 }
707
708 test_finish_ () {
709 echo >&3 ""
710 maybe_teardown_valgrind
711 maybe_teardown_verbose
712 }
713
714 test_skip () {
715 to_skip=
716 skipped_reason=
717 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
718 then
719 to_skip=t
720 skipped_reason="GIT_SKIP_TESTS"
721 fi
722 if test -z "$to_skip" && test -n "$test_prereq" &&
723 ! test_have_prereq "$test_prereq"
724 then
725 to_skip=t
726
727 of_prereq=
728 if test "$missing_prereq" != "$test_prereq"
729 then
730 of_prereq=" of $test_prereq"
731 fi
732 skipped_reason="missing $missing_prereq${of_prereq}"
733 fi
734 if test -z "$to_skip" && test -n "$run_list" &&
735 ! match_test_selector_list '--run' $test_count "$run_list"
736 then
737 to_skip=t
738 skipped_reason="--run"
739 fi
740
741 case "$to_skip" in
742 t)
743 say_color skip >&3 "skipping test: $@"
744 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
745 : true
746 ;;
747 *)
748 false
749 ;;
750 esac
751 }
752
753 # stub; perf-lib overrides it
754 test_at_end_hook_ () {
755 :
756 }
757
758 test_done () {
759 GIT_EXIT_OK=t
760
761 if test -z "$HARNESS_ACTIVE"
762 then
763 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
764 mkdir -p "$test_results_dir"
765 base=${0##*/}
766 test_results_path="$test_results_dir/${base%.sh}.counts"
767
768 cat >"$test_results_path" <<-EOF
769 total $test_count
770 success $test_success
771 fixed $test_fixed
772 broken $test_broken
773 failed $test_failure
774
775 EOF
776 fi
777
778 if test "$test_fixed" != 0
779 then
780 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
781 fi
782 if test "$test_broken" != 0
783 then
784 say_color warn "# still have $test_broken known breakage(s)"
785 fi
786 if test "$test_broken" != 0 || test "$test_fixed" != 0
787 then
788 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
789 msg="remaining $test_remaining test(s)"
790 else
791 test_remaining=$test_count
792 msg="$test_count test(s)"
793 fi
794 case "$test_failure" in
795 0)
796 if test $test_external_has_tap -eq 0
797 then
798 if test $test_remaining -gt 0
799 then
800 say_color pass "# passed all $msg"
801 fi
802
803 # Maybe print SKIP message
804 test -z "$skip_all" || skip_all="# SKIP $skip_all"
805 case "$test_count" in
806 0)
807 say "1..$test_count${skip_all:+ $skip_all}"
808 ;;
809 *)
810 test -z "$skip_all" ||
811 say_color warn "$skip_all"
812 say "1..$test_count"
813 ;;
814 esac
815 fi
816
817 if test -z "$debug"
818 then
819 test -d "$TRASH_DIRECTORY" ||
820 error "Tests passed but trash directory already removed before test cleanup; aborting"
821
822 cd "$TRASH_DIRECTORY/.." &&
823 rm -fr "$TRASH_DIRECTORY" ||
824 error "Tests passed but test cleanup failed; aborting"
825 fi
826 test_at_end_hook_
827
828 exit 0 ;;
829
830 *)
831 if test $test_external_has_tap -eq 0
832 then
833 say_color error "# failed $test_failure among $msg"
834 say "1..$test_count"
835 fi
836
837 exit 1 ;;
838
839 esac
840 }
841
842 if test -n "$valgrind"
843 then
844 make_symlink () {
845 test -h "$2" &&
846 test "$1" = "$(readlink "$2")" || {
847 # be super paranoid
848 if mkdir "$2".lock
849 then
850 rm -f "$2" &&
851 ln -s "$1" "$2" &&
852 rm -r "$2".lock
853 else
854 while test -d "$2".lock
855 do
856 say "Waiting for lock on $2."
857 sleep 1
858 done
859 fi
860 }
861 }
862
863 make_valgrind_symlink () {
864 # handle only executables, unless they are shell libraries that
865 # need to be in the exec-path.
866 test -x "$1" ||
867 test "# " = "$(head -c 2 <"$1")" ||
868 return;
869
870 base=$(basename "$1")
871 case "$base" in
872 test-*)
873 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
874 ;;
875 *)
876 symlink_target="$GIT_BUILD_DIR/$base"
877 ;;
878 esac
879 # do not override scripts
880 if test -x "$symlink_target" &&
881 test ! -d "$symlink_target" &&
882 test "#!" != "$(head -c 2 < "$symlink_target")"
883 then
884 symlink_target=../valgrind.sh
885 fi
886 case "$base" in
887 *.sh|*.perl)
888 symlink_target=../unprocessed-script
889 esac
890 # create the link, or replace it if it is out of date
891 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
892 }
893
894 # override all git executables in TEST_DIRECTORY/..
895 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
896 mkdir -p "$GIT_VALGRIND"/bin
897 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
898 do
899 make_valgrind_symlink $file
900 done
901 # special-case the mergetools loadables
902 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
903 OLDIFS=$IFS
904 IFS=:
905 for path in $PATH
906 do
907 ls "$path"/git-* 2> /dev/null |
908 while read file
909 do
910 make_valgrind_symlink "$file"
911 done
912 done
913 IFS=$OLDIFS
914 PATH=$GIT_VALGRIND/bin:$PATH
915 GIT_EXEC_PATH=$GIT_VALGRIND/bin
916 export GIT_VALGRIND
917 GIT_VALGRIND_MODE="$valgrind"
918 export GIT_VALGRIND_MODE
919 GIT_VALGRIND_ENABLED=t
920 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
921 export GIT_VALGRIND_ENABLED
922 elif test -n "$GIT_TEST_INSTALLED"
923 then
924 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
925 error "Cannot run git from $GIT_TEST_INSTALLED."
926 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
927 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
928 else # normal case, use ../bin-wrappers only unless $with_dashes:
929 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
930 if ! test -x "$git_bin_dir/git"
931 then
932 if test -z "$with_dashes"
933 then
934 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
935 fi
936 with_dashes=t
937 fi
938 PATH="$git_bin_dir:$PATH"
939 GIT_EXEC_PATH=$GIT_BUILD_DIR
940 if test -n "$with_dashes"
941 then
942 PATH="$GIT_BUILD_DIR:$PATH"
943 fi
944 fi
945 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
946 GIT_CONFIG_NOSYSTEM=1
947 GIT_ATTR_NOSYSTEM=1
948 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
949
950 if test -z "$GIT_TEST_CMP"
951 then
952 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
953 then
954 GIT_TEST_CMP="$DIFF -c"
955 else
956 GIT_TEST_CMP="$DIFF -u"
957 fi
958 fi
959
960 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
961 export GITPERLLIB
962 test -d "$GIT_BUILD_DIR"/templates/blt || {
963 error "You haven't built things yet, have you?"
964 }
965
966 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
967 then
968 echo >&2 'You need to build test-tool:'
969 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
970 exit 1
971 fi
972
973 # Test repository
974 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
975 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
976 case "$TRASH_DIRECTORY" in
977 /*) ;; # absolute path is good
978 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
979 esac
980 rm -fr "$TRASH_DIRECTORY" || {
981 GIT_EXIT_OK=t
982 echo >&5 "FATAL: Cannot prepare test area"
983 exit 1
984 }
985
986 HOME="$TRASH_DIRECTORY"
987 GNUPGHOME="$HOME/gnupg-home-not-used"
988 export HOME GNUPGHOME
989
990 if test -z "$TEST_NO_CREATE_REPO"
991 then
992 test_create_repo "$TRASH_DIRECTORY"
993 else
994 mkdir -p "$TRASH_DIRECTORY"
995 fi
996 # Use -P to resolve symlinks in our working directory so that the cwd
997 # in subprocesses like git equals our $PWD (for pathname comparisons).
998 cd -P "$TRASH_DIRECTORY" || exit 1
999
1000 this_test=${0##*/}
1001 this_test=${this_test%%-*}
1002 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1003 then
1004 say_color info >&3 "skipping test $this_test altogether"
1005 skip_all="skip all tests in $this_test"
1006 test_done
1007 fi
1008
1009 # Provide an implementation of the 'yes' utility
1010 yes () {
1011 if test $# = 0
1012 then
1013 y=y
1014 else
1015 y="$*"
1016 fi
1017
1018 i=0
1019 while test $i -lt 99
1020 do
1021 echo "$y"
1022 i=$(($i+1))
1023 done
1024 }
1025
1026 # Fix some commands on Windows
1027 uname_s=$(uname -s)
1028 case $uname_s in
1029 *MINGW*)
1030 # Windows has its own (incompatible) sort and find
1031 sort () {
1032 /usr/bin/sort "$@"
1033 }
1034 find () {
1035 /usr/bin/find "$@"
1036 }
1037 # git sees Windows-style pwd
1038 pwd () {
1039 builtin pwd -W
1040 }
1041 # no POSIX permissions
1042 # backslashes in pathspec are converted to '/'
1043 # exec does not inherit the PID
1044 test_set_prereq MINGW
1045 test_set_prereq NATIVE_CRLF
1046 test_set_prereq SED_STRIPS_CR
1047 test_set_prereq GREP_STRIPS_CR
1048 GIT_TEST_CMP=mingw_test_cmp
1049 ;;
1050 *CYGWIN*)
1051 test_set_prereq POSIXPERM
1052 test_set_prereq EXECKEEPSPID
1053 test_set_prereq CYGWIN
1054 test_set_prereq SED_STRIPS_CR
1055 test_set_prereq GREP_STRIPS_CR
1056 ;;
1057 *)
1058 test_set_prereq POSIXPERM
1059 test_set_prereq BSLASHPSPEC
1060 test_set_prereq EXECKEEPSPID
1061 ;;
1062 esac
1063
1064 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1065 test -z "$NO_PERL" && test_set_prereq PERL
1066 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1067 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1068 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1069 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1070 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1071 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1072
1073 # Can we rely on git's output in the C locale?
1074 if test -n "$GETTEXT_POISON"
1075 then
1076 GIT_GETTEXT_POISON=YesPlease
1077 export GIT_GETTEXT_POISON
1078 test_set_prereq GETTEXT_POISON
1079 else
1080 test_set_prereq C_LOCALE_OUTPUT
1081 fi
1082
1083 test_lazy_prereq PIPE '
1084 # test whether the filesystem supports FIFOs
1085 test_have_prereq !MINGW,!CYGWIN &&
1086 rm -f testfifo && mkfifo testfifo
1087 '
1088
1089 test_lazy_prereq SYMLINKS '
1090 # test whether the filesystem supports symbolic links
1091 ln -s x y && test -h y
1092 '
1093
1094 test_lazy_prereq FILEMODE '
1095 test "$(git config --bool core.filemode)" = true
1096 '
1097
1098 test_lazy_prereq CASE_INSENSITIVE_FS '
1099 echo good >CamelCase &&
1100 echo bad >camelcase &&
1101 test "$(cat CamelCase)" != good
1102 '
1103
1104 test_lazy_prereq UTF8_NFD_TO_NFC '
1105 # check whether FS converts nfd unicode to nfc
1106 auml=$(printf "\303\244")
1107 aumlcdiar=$(printf "\141\314\210")
1108 >"$auml" &&
1109 case "$(echo *)" in
1110 "$aumlcdiar")
1111 true ;;
1112 *)
1113 false ;;
1114 esac
1115 '
1116
1117 test_lazy_prereq AUTOIDENT '
1118 sane_unset GIT_AUTHOR_NAME &&
1119 sane_unset GIT_AUTHOR_EMAIL &&
1120 git var GIT_AUTHOR_IDENT
1121 '
1122
1123 test_lazy_prereq EXPENSIVE '
1124 test -n "$GIT_TEST_LONG"
1125 '
1126
1127 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1128 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1129 '
1130
1131 test_lazy_prereq USR_BIN_TIME '
1132 test -x /usr/bin/time
1133 '
1134
1135 test_lazy_prereq NOT_ROOT '
1136 uid=$(id -u) &&
1137 test "$uid" != 0
1138 '
1139
1140 test_lazy_prereq JGIT '
1141 type jgit
1142 '
1143
1144 # SANITY is about "can you correctly predict what the filesystem would
1145 # do by only looking at the permission bits of the files and
1146 # directories?" A typical example of !SANITY is running the test
1147 # suite as root, where a test may expect "chmod -r file && cat file"
1148 # to fail because file is supposed to be unreadable after a successful
1149 # chmod. In an environment (i.e. combination of what filesystem is
1150 # being used and who is running the tests) that lacks SANITY, you may
1151 # be able to delete or create a file when the containing directory
1152 # doesn't have write permissions, or access a file even if the
1153 # containing directory doesn't have read or execute permissions.
1154
1155 test_lazy_prereq SANITY '
1156 mkdir SANETESTD.1 SANETESTD.2 &&
1157
1158 chmod +w SANETESTD.1 SANETESTD.2 &&
1159 >SANETESTD.1/x 2>SANETESTD.2/x &&
1160 chmod -w SANETESTD.1 &&
1161 chmod -r SANETESTD.1/x &&
1162 chmod -rx SANETESTD.2 ||
1163 error "bug in test sript: cannot prepare SANETESTD"
1164
1165 ! test -r SANETESTD.1/x &&
1166 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1167 status=$?
1168
1169 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1170 rm -rf SANETESTD.1 SANETESTD.2 ||
1171 error "bug in test sript: cannot clean SANETESTD"
1172 return $status
1173 '
1174
1175 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1176 GIT_UNZIP=${GIT_UNZIP:-unzip}
1177 test_lazy_prereq UNZIP '
1178 "$GIT_UNZIP" -v
1179 test $? -ne 127
1180 '
1181
1182 run_with_limited_cmdline () {
1183 (ulimit -s 128 && "$@")
1184 }
1185
1186 test_lazy_prereq CMDLINE_LIMIT '
1187 test_have_prereq !MINGW,!CYGWIN &&
1188 run_with_limited_cmdline true
1189 '
1190
1191 run_with_limited_stack () {
1192 (ulimit -s 128 && "$@")
1193 }
1194
1195 test_lazy_prereq ULIMIT_STACK_SIZE '
1196 test_have_prereq !MINGW,!CYGWIN &&
1197 run_with_limited_stack true
1198 '
1199
1200 build_option () {
1201 git version --build-options |
1202 sed -ne "s/^$1: //p"
1203 }
1204
1205 test_lazy_prereq LONG_IS_64BIT '
1206 test 8 -le "$(build_option sizeof-long)"
1207 '
1208
1209 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1210 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1211
1212 test_lazy_prereq CURL '
1213 curl --version
1214 '